#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include "grid/hash.h"
#include "grid/vd.h"
#include "grid/grid.h"
#include "grid/graphics.h"
#include "grid/ie.h"
#include "grid/catchment.h"
#include "arrays.h"   /* Pack functions decs */
#include "arrays.c"   /* Pack functions defs */


MODULE = Grid		PACKAGE = Grid


int 
gddebug(dbg)
	int dbg

int 
gdhashmarks(h)
	int h

int 
gdsigint(s)
	int s

cell *
cellnew()

int 
celldestroy(c)
	cell *c

int 
gdsetmask(gd)
	grid *gd

grid *
gdgetmask()

int 
gdremovemask()
	CODE:
	{
		gdsetmask(NULL);
		RETVAL = 1;
	}
  OUTPUT:
    RETVAL

int 
gddestroy(gd)
	grid *gd

grid *
gdnew(datatype, M, N)
	int datatype
	int M
	int N

int
gdcopy(to, from)
	grid *to
	grid *from

grid *
gdcreatecopy(gd, datatype)
	grid *gd
	int datatype

grid *
gdopen(basename)
	char *basename

int 
gdread(gd, basename, ext, el_size, byteorder)
	grid *gd
	char *basename
	char *ext
	int el_size
	int byteorder

int 
gdsave(gd, basename)
	grid *gd
	char *basename

int 
gdwrite(gd, basename, ext)
	grid *gd
	char *basename
	char *ext

int 
gdsetnodata(gd, nodata)
	grid *gd
	double nodata

double 
gdgetnodata(gd)
	grid *gd

int
gdgetM(gd)
	grid *gd

int
gdgetN(gd)
	grid *gd

int
gddatatype(gd)
	grid *gd

double
gdunitdist(gd)
	grid *gd

double 
gdminX(gd)
	grid *gd

double 
gdmaxX(gd)
	grid *gd

double 
gdminY(gd)
	grid *gd

double 
gdmaxY(gd)
	grid *gd

int
gdsetbounds(gd, unitdist, minX, minY)
	grid *gd
	double unitdist
	double minX
	double minY

int
gdsetbounds2(gd, unitdist, minX, maxY)
	grid *gd
	double unitdist
	double minX
	double maxY

int
gdsetbounds3(gd, unitdist, maxX, minY)
	grid *gd
	double unitdist
	double maxX
	double minY

int
gdsetbounds4(gd, minX, maxX, minY)
	grid *gd
	double minX
	double maxX
	double minY

int
gdsetbounds5(gd, minX, maxX, maxY)
	grid *gd
	double minX
	double maxX
	double maxY

int
gdsetbounds6(gd, minX, minY, maxY)
	grid *gd
	double minX
	double minY
	double maxY

int
gdsetbounds7(gd, maxX, minY, maxY)
	grid *gd
	double maxX
	double minY
	double maxY

int 
gdcopybounds(from, to)
	grid *from
	grid *to

int 
gdx2j(gd, x)
	grid *gd
	double x

int 
gdy2i(gd, y)
	grid *gd
	double y

double 
gdj2x(gd, j)
	grid *gd
	int j

double 
gdi2y(gd, i)
	grid *gd
	int i

int 
gdset(gd, i, j, x)
	grid *gd
	int i
	int j
	double x

double 
gdget(gd, i, j)
	grid *gd
	int i
	int j

int 
gdsetminmax(gd)
	grid *gd

double 
gdgetminval(gd)
	grid *gd

double 
gdgetmaxval(gd)
	grid *gd

AV *
_gdgetmin(gd)
	grid *gd
	CODE:
	{
		cell c = gdgetmin(gd);
		AV *av = newAV();
		if (av) {
			SV *sv = newSViv(c.i);
			av_push(av, sv);
			sv = newSViv(c.j);
			av_push(av, sv);
		}
		RETVAL = av;
	}
  OUTPUT:
    RETVAL

AV * 
_gdgetmax(gd)
	grid *gd
	CODE:
	{
		cell c = gdgetmax(gd);
		AV *av = newAV();
		if (av) {
			SV *sv = newSViv(c.i);
			av_push(av, sv);
			sv = newSViv(c.j);
			av_push(av, sv);
		}
		RETVAL = av;
	}
  OUTPUT:
    RETVAL

int 
gdsetall(gd, x)
	grid *gd
	double x

int 
gddata(gd)
	grid *gd

int 
gdnot(gd)
	grid *gd

int 
gdandgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdorgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdaddsv(gd, x)
	grid *gd
	double x

int 
gdaddgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdsubgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdmultsv(gd, x)
	grid *gd
	double x

int 
gdmultgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gddivsv(gd, x)
	grid *gd
	double x

int
svdivgd(x, gd)
	double x
	grid *gd

int 
gddivgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdmodulussv(gd, x)
	grid *gd
	double x

int
svmodulusgd(x, gd)
	double x
	grid *gd

int 
gdmodulusgd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdpowersv(gd, x)
	grid *gd
	double x

int
svpowergd(x, gd)
	double x
	grid *gd

int 
gdpowergd(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdabs(gd)
	grid *gd

int 
gdacos(gd)
	grid *gd

int 
gdatan(gd)
	grid *gd

int 
gdatan2(gd1, gd2)
	grid *gd1
	grid *gd2

int 
gdceil(gd)
	grid *gd

int 
gdcos(gd)
	grid *gd

int 
gdcosh(gd)
	grid *gd

int 
gdexp(gd)
	grid *gd

int 
gdfloor(gd)
	grid *gd

int 
gdlog(gd)
	grid *gd

int 
gdlog10(gd)
	grid *gd

int 
gdpow(gd, b)
	grid *gd
	double b

int 
gdsin(gd)
	grid *gd

int 
gdsinh(gd)
	grid *gd

int 
gdsqrt(gd)
	grid *gd

int 
gdtan(gd)
	grid *gd

int 
gdtanh(gd)
	grid *gd

grid *
gdround(gd)
	grid *gd

int
gdltsv(gd, x)
	grid *gd
	double x

int
gdgtsv(gd, x)
	grid *gd
	double x

int
gdlesv(gd, x)
	grid *gd
	double x

int
gdgesv(gd, x)
	grid *gd
	double x

int
gdeqsv(gd, x)
	grid *gd
	double x

int
gdnesv(gd, x)
	grid *gd
	double x

int
gdcmpsv(gd, x)
	grid *gd
	double x

int
gdltgd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdgtgd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdlegd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdgegd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdeqgd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdnegd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdcmpgd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdminsv(gd, x)
	grid *gd
	double x

int
gdmaxsv(gd, x)
	grid *gd
	double x

int
gdmingd(gd1, gd2)
	grid *gd1
	grid *gd2

int
gdmaxgd(gd1, gd2)
	grid *gd1
	grid *gd2

grid *
gdcross(a, b)
	grid *a
	grid *b

int 
gdif_thensv(a, b, c)
	grid *a
	grid *b
	double c

int 
gdif_thengd(a, b, c)
	grid *a
	grid *b
	grid *c

int 
gdzonal_if_then(a, b, k, v, n)
	grid *a
	grid *b
	int *k
	double *v
	int n

int 
gdbinary(gd)
	grid *gd

int 
gdapplytempl(gd, templ, new_val)
	grid *gd
	int *templ
	int new_val

int
gdmap(gd, s, d, n)
	grid *gd
	int *s
	int *d
	int n

double 
_gdzonesize(gd, i, j)
	grid *gd
	int i
	int j
	CODE:
	{	
		cell c = {i, j};
		RETVAL = gdzonesize(gd, c);
  	}
  OUTPUT:
    RETVAL

grid *
gdborders(gd)
	grid *gd

grid *
gdborders2(gd)
	grid *gd

grid *
gdareas(gd, k)
	grid *gd
	int k

int 
gdconnect(gd) 
	grid *gd

int
gdnrareas(gd,connectivity)
	grid *gd
	int connectivity

grid *
gdclip(gd, i1, j1, i2, j2)
	grid *gd
	int i1
	int j1
	int i2
	int j2

grid *
gdjoin(g1, g2)
	grid *g1
	grid *g2

grid *
gdtransform(gd, tr, M, N)
	grid *gd
	double *tr
	int M
	int N

grid *
a2gd(datatype, M, N, infile, mode)
	int datatype
	int M
	int N
	char *infile
	int mode

int
gd2a(gd, outfile)
	grid *gd
	char *outfile

int 
gdline(gd, i1, j1, i2, j2, pen)
	grid *gd
	int i1
	int j1
	int i2
	int j2
	double pen

int 
gdfilledrect(gd, i1, j1, i2, j2, pen)
	grid *gd
	int i1
	int j1
	int i2
	int j2
	double pen

void
gdfilledcircle(gd, i, j, r, r2, pen)
	grid *gd
	int i
	int j
	int r
	int r2
	double pen

int 
_gdfloodfill(gd, i, j, icolor, rcolor, connectivity)
	grid *gd
	int i
	int j
	int icolor
	double rcolor
	int connectivity
	CODE:
	{	
		cell c = {i, j};
		RETVAL = gdfloodfill(gd, c, icolor, rcolor, connectivity);
  	}
  OUTPUT:
    RETVAL

color_table *
ctcreate(nc, contra, bright)
	int nc
	double contra
	double bright

int 
ctdestroy(ct)
	color_table *ct

int 
ctset(ct, i, l, r, g, b)
	color_table *ct
	int i
	double l
	double r
	double g
	double b

int 
ctsize(ct)
	color_table *ct

double 
ctget_contrast(ct)
	color_table *ct

double 
ctget_brightness(ct)
	color_table *ct

double 
ctgetl(ct, i)
	color_table *ct
	int i

double 
ctgetr(ct, i)
	color_table *ct
	int i

double 
ctgetg(ct, i)
	color_table *ct
	int i

double 
ctgetb(ct, i)
	color_table *ct
	int i

grid *
ppm2gd(datatype, infile, channel)
	int datatype
	char *infile
	int channel

int
gd2ppm(gd, outfile, ct)
	grid *gd
	char *outfile
	color_table *ct

point_data *
pointcreate(x, y, color, line_width, symbol, symbol_height, symbol_font, label, label_placement)
	double x
	double y
	int color
	int line_width
	int symbol
	double symbol_height
	int symbol_font
	char *label
	int label_placement

int 
pointdestroy(p)
	point_data *p

lseg_data *
lsegcreate(x1, y1, x2, y2, color, style, width, arrow, arrow_angle, arrow_barb, label,  label_placement)
	double x1
	double y1
	double x2
	double y2
	int color
	int style
	int width
	int arrow
	double arrow_angle
	double arrow_barb
	char *label
	int label_placement

int 
lsegdestroy(lseg)
	lseg_data *lseg

polygon_data *
polygoncreate(n, x, y, color, line_style, line_width, fill_style, fill_line_angle, fill_line_sepn, fill_line_phase, label, label_placement)
	int n
	double *x
	double *y
	int color
	int line_style
	int line_width
	int fill_style
	double fill_line_angle
	double fill_line_sepn
	double fill_line_phase
	char *label
	int label_placement

int 
polygondestroy(polygon)
	polygon_data *polygon

vector_data *
vdnull()

vector_data *
vdcreate(name, id, label_color, label_line_width, label_font, label_height)
	char *name
	int id
	int label_color
	int label_line_width
	int label_font
	int label_height

int 
vddestroy(vd)
	vector_data *vd

int 
vdget_id(vd)
	vector_data *vd

vector_data *
vdnext(vd)
	vector_data *vd

int 
vdbreaklist(vd)
	vector_data *vd

int 
vdaddvd(root, vd)
	vector_data *root
	vector_data *vd

int 
vdaddpoint(vd, point)
	vector_data *vd
	point_data *point

int 
vdaddlseg(vd, lseg)
	vector_data *vd
	lseg_data *lseg

int 
vdaddpolygon(vd, polygon)
	vector_data *vd
	polygon_data *polygon

int 
gdwindow_open()

int 
gdwindow_close(window)
	int window

grid *
gdpaint(gd, vd, device, window, ct, draw, options)
	grid *gd
	vector_data *vd
	char *device
	int window
	color_table *ct
	int draw
	int options

int
gdprint(gd)
	grid *gd

AV *
_gdprint1(gd, quiet, wc)
	grid *gd
	int quiet
	int wc
	CODE:
	{	
		double *p = NULL;
		int i, psize = 0;
		AV *av = newAV();
		if (!av) goto fail;
		if (gdprint1(gd, &p, &psize, quiet, wc)) 
		for (i=0; i<psize; i++) {
			SV *sv = newSVnv(p[i]);
			if (!sv) goto fail;
			av_push(av, sv);
		}
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		if (p) free(p);
		RETVAL = av;
  	}
  OUTPUT:
    RETVAL

AV *
_gdhistogram(gd, bin, n)
	grid *gd
	double *bin
	int n
	CODE:
	{
		int i, *c = NULL;
		AV *counts = newAV();
		if (!counts) goto fail;
		c = (int *)calloc(n+1,sizeof(int));
		if (!c) goto fail;
		if (gdhistogram(gd, bin, c, n))
		for (i=0; i<n+1; i++) {
			SV *sv = newSViv(c[i]);
			if (!sv) goto fail;
			av_push(counts, sv);
		}
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		if (c) free(c);
		RETVAL = counts;
	}
  OUTPUT:
    RETVAL

HV *
_gdcontents(gd)
	grid *gd
	CODE:
	{
		hash table;
		int i;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdcontents(gd, &table))
		for (i = 0; i < table.size; i++) {
			hash_int_item *a = (hash_int_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSViv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

HV *
_gdzonalcount(gd, zones)
	grid *gd
	grid *zones
	CODE:
	{
		hash table;
		int i, n = 0;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdzonalcount(gd, zones, &table))
		for (i = 0; i < table.size; i++) {
			hash_int_item *a = (hash_int_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSViv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

HV *
_gdzonalsum(gd, zones)
	grid *gd
	grid *zones
	CODE:
	{
		hash table;
		int i, n = 0;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdzonalsum(gd, zones, &table))
		for (i = 0; i < table.size; i++) {
			hash_double_item *a = (hash_double_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSVnv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

HV *
_gdzonalmin(gd, zones)
	grid *gd
	grid *zones
	CODE:
	{
		hash table;
		int i, n = 0;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdzonalmin(gd, zones, &table))
		for (i = 0; i < table.size; i++) {
			hash_double_item *a = (hash_double_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSVnv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

HV *
_gdzonalmax(gd, zones)
	grid *gd
	grid *zones
	CODE:
	{
		hash table;
		int i, n = 0;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdzonalmax(gd, zones, &table))
		for (i = 0; i < table.size; i++) {
			hash_double_item *a = (hash_double_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSVnv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

HV *
_gdzonalmean(gd, zones)
	grid *gd
	grid *zones
	CODE:
	{
		hash table;
		int i, n = 0;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdzonalmean(gd, zones, &table))
		for (i = 0; i < table.size; i++) {
			hash_double_item *a = (hash_double_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSVnv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

HV *
_gdzonalvariance(gd, zones)
	grid *gd
	grid *zones
	CODE:
	{
		hash table;
		int i, n = 0;
		HV* h = newHV();
		if (!h) goto fail;
		if (!hash_create(&table, 200)) goto ok;
		if (gdzonalvariance(gd, zones, &table))
		for (i = 0; i < table.size; i++) {
			hash_double_item *a = (hash_double_item *)table.table[i];
			while (a) {
				U32 klen;
				char key[10];
				SV *sv = newSVnv(a->value);
				if (!sv) goto fail;
				snprintf(key, 10, "%i", a->key);
				klen = strlen(key);
				hv_store(h, key, klen, sv, 0);
				a = a->next;
			}
		}
		hash_destroy(&table);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

int 
gdgrowzones(zones, grow, connectivity)
	grid *zones
	grid *grow
	int connectivity

HV *
_gdneighbors(gd)
	grid *gd
	CODE:
	{
		hash **b;
		int *c, i, j, n;
		HV* h = newHV();
		if (!h) goto fail;
		if (!gdneighbors(gd, &b, &c, &n)) goto fail;
		for (i = 0; i < n; i++) {
			char key[10];
			AV*  av = newAV();
			U32 klen;
			int j;
			if (!av) goto fail;
			snprintf(key, 10, "%i", c[i]);
			klen = strlen(key);
			for (j = 0; j < b[i]->size; j++) {
				hash_int_item *a = (hash_int_item *)b[i]->table[j];
				while (a) {
					SV *sv = newSViv(a->key);
					if (!sv) goto fail;
					av_push(av, sv);
					a = a->next;
				}				
			}
			hv_store(h, key, klen, newRV_inc((SV*) av), 0);
		}
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		if (b) {
			for (i = 0; i < n; i++) {
				if (b[i]) {
					hash_destroy(b[i]);
					free(b[i]);
				}
			}
			free(b);
		}
		if (c) free(c);
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

grid *
gdbufferzone(gd, z, w)
	grid *gd
	int z
	double w

int
gdcount(gd)
	grid *gd

double 
gdsum(gd)
	grid *gd

double 
gdmean(gd)
	grid *gd

double 
gdvariance(gd)
	grid *gd

grid *
gddistances(gd)
	grid *gd

grid *
gddirections(gd)
	grid *gd

grid *
gdnn(gd)
	grid *gd

HV *
_gdzones(gd, z)
	grid *gd
	grid *z
	CODE:
	{
		double **tot = NULL;
		int *c = NULL;
		int *k = NULL;
		int i, n;
		HV* hv = newHV();
		if (!hv) goto fail;
		if (gdzones(gd, z, &tot, &c, &k, &n)) {
			for (i = 0; i < n; i++) if (k[i]) {
				int j;
				char key[10];
				U32 klen;
				AV *av;
				SV **sv = (SV **)calloc(k[i], sizeof(SV *));
				if (!sv) goto fail;
				for (j = 0; j < k[i]; j++) {
					sv[j] = newSVnv(tot[i][j]);
					if (!sv[j]) goto fail;
				}
				av = av_make(k[i], sv);
				snprintf(key, 10, "%i", c[i]);
				klen = strlen(key);
				hv_store(hv, key, klen, newRV_inc((SV*)av), 0);
			}
		}
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		if (tot) {
			for (i = 0; i < n; i++)
				if (tot[i]) free(tot[i]);
			free(tot);
		}
		if (c) free(c);
		if (k) free(k);
		RETVAL = hv;
	}
  OUTPUT:
    RETVAL

grid *
dem2aspect(dem)
	grid *dem

grid *
dem2slope(dem, z_factor)
	grid *dem
	double z_factor

grid *
dem2fdg(dem, method)
	grid *dem
	int method

grid *
dem2ucg(dem) 
	grid *dem

int
fdg_fixflats1(fdg, dem)
	grid *fdg
	grid *dem

int
fdg_fixflats2(fdg, dem)
	grid *fdg
	grid *dem

int 
dem_fillpits(dem, z_limit)
	grid *dem
	double z_limit

int 
dem_cutpeaks(dem, z_limit)
	grid *dem
	double z_limit

grid *
dem_depressions(dem, fdg, inc_m)
	grid *dem
	grid *fdg
	int inc_m

int 
dem_filldepressions(dem, fdg)
	grid *dem
	grid *fdg

int 
dem_breach(dem, fdg, limit)
	grid *dem
	grid *fdg
	int limit

int 
fdg_fixpits(fdg, dem)
	grid *fdg
	grid *dem

int 
water_route(water, dem, fdg, flow, k, d, f, r)
	grid *water
	grid *dem
	grid *fdg
	grid *flow
	grid *k
	grid *d
	int f
	double r

grid *
_fdg2uag_a(fdg)
	grid *fdg
	CODE:
	{
		RETVAL = fdg2uag(fdg, NULL);
	}
  OUTPUT:	
	RETVAL

grid *
_fdg2uag_b(fdg, load)
	grid *fdg
	grid *load
	CODE:
	{
		RETVAL = fdg2uag(fdg, load);
	}
  OUTPUT:	
	RETVAL

grid *
fdg_distance_to_channel(fdg, streams) 
	grid *fdg
	grid *streams

grid *
fdg_distance_to_divide(fdg)
	grid *fdg

grid *
dem2uag(dem, fdg, recursion) 
	grid *dem
	grid *fdg
	int recursion

grid *
dem2dag(dem, fdg)
	grid *dem
	grid *fdg

int 
fdg_catchment(fdg, mark, i, j, m)
	grid *fdg
	grid *mark
	int i
	int j
	int m
	CODE:
	{	
		pour_point_struct pp;
		if (!init_pour_point_struct(&pp, fdg, NULL, mark)) 
			RETVAL = 0;
		else {
			cell c = {i, j};
			if (!GD_CELLIN(fdg, c)) {
	    			fprintf(stderr,"fdg_catchment: the cell %i,%i is not within FDG\n",i,j);
	    			RETVAL = 0;
			} else {
				RETVAL = rmb(&pp, c, m);
			}
		}
  	}
  OUTPUT:
    RETVAL

grid *
streams_subcatchments(streams, fdg, i, j)
	grid *streams
	grid *fdg
	int i
	int j

int
streams_number(streams, fdg, i, j, sid0)
	grid *streams
	grid *fdg
	int i
	int j
	int sid0

int 
fdg_killoutlets(fdg, lakes, uag)
	grid *fdg
	grid *lakes
	grid *uag

int 
streams_prune(streams, fdg, lakes, i, j, min_l)
	grid *streams
	grid *fdg
	grid *lakes
	int i
	int j
	double min_l

int 
_streams_prune(streams, fdg, i, j, min_l)
	grid *streams
	grid *fdg
	int i
	int j
	double min_l
	CODE:
	{
		RETVAL = streams_prune(streams, fdg, NULL, i, j, min_l);
	}
  OUTPUT:
    RETVAL



int 
streams_break(streams, fdg, lakes, nsid)
	grid *streams
	grid *fdg
	grid *lakes
	int nsid

HV *
_subcatchments(sheds, streams, fdg, lakes, i, j, headwaters)
	grid *sheds
	grid *streams
	grid *fdg
	grid *lakes
	int i
	int j
	int headwaters
	CODE:
	{
		ws w;
		HV *h = newHV();
		if (!h) goto fail;
		if (ws_subcatchments(&w, sheds, streams, fdg, lakes, i, j, headwaters))
		for (i = 0; i < w.n; i++) {
			char key[20];
			SV *sv;
			U32 klen;
			snprintf(key, 20, "%i,%i", w.down[i].i, w.down[i].j);
			klen = strlen(key);
			sv = newSVpv(key, klen);
			if (!sv) goto fail;
			snprintf(key, 20, "%i,%i", w.outlet[i].i, w.outlet[i].j);
			klen = strlen(key);
			hv_store(h, key, klen, sv, 0);
		}
		wsempty(&w);
		goto ok;
	fail:
		fprintf(stderr,"Out of memory!\n");
	ok:
		RETVAL = h;
	}
  OUTPUT:
    RETVAL

