#ifndef GRAPHICS_H
#define GRAPHICS_H

typedef struct {
    float *l;
    float *r;
    float *g;
    float *b;
    int nc;
    float contra;
    float bright;
} color_table;

color_table *ctcreate(int nc, double contra, double bright);
int ctdestroy(color_table *ct);
int ctset(color_table *ct, int i, double l, double r, double g, double b);
int ctsize(color_table *ct);
double ctget_contrast(color_table *ct);
double ctget_brightness(color_table *ct);
double ctgetl(color_table *ct, int i);
double ctgetr(color_table *ct, int i);
double ctgetg(color_table *ct, int i);
double ctgetb(color_table *ct, int i);

#ifdef HAVE_PGPLOT

/* open and close a xserve window for use with gdpaint */
int gdwindow_open();
int gdwindow_close(int window);

/* 
   window should be 0 or an id acquired with gdwindow_open

   if draw < 0, just plots, 
   if draw == 0, lets the user view & zoom, 
   if draw > 0 lets the user draw and returns the drawing
   
   options is a collection of flags: 
*/

#define RASTER_FLAG 1
#define VECTOR_FLAG 2
#define LABEL_FLAG 4
#define SCALE_FLAG 8

grid *gdpaint(grid *gd, 
	      vector_data *vd, 
	      char *device, 
	      int window,
	      color_table *ct, 
	      int draw, 
	      int options);
#endif

#endif
